//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private EminiJunkieBands[] cacheEminiJunkieBands = null;
        private EminiJunkieBIAS[] cacheEminiJunkieBIAS = null;
        private EminiJunkieChop[] cacheEminiJunkieChop = null;
        private EminiJunkieKeyLevels[] cacheEminiJunkieKeyLevels = null;
        private EminiJunkieKIS[] cacheEminiJunkieKIS = null;
        private EminiJunkieMACloud[] cacheEminiJunkieMACloud = null;
        private EminiJunkieSMI[] cacheEminiJunkieSMI = null;
        private EminiJunkieSpread[] cacheEminiJunkieSpread = null;
        private EminiJunkieTrailingStop[] cacheEminiJunkieTrailingStop = null;

        private static EminiJunkieBands checkEminiJunkieBands = new EminiJunkieBands();
        private static EminiJunkieBIAS checkEminiJunkieBIAS = new EminiJunkieBIAS();
        private static EminiJunkieChop checkEminiJunkieChop = new EminiJunkieChop();
        private static EminiJunkieKeyLevels checkEminiJunkieKeyLevels = new EminiJunkieKeyLevels();
        private static EminiJunkieKIS checkEminiJunkieKIS = new EminiJunkieKIS();
        private static EminiJunkieMACloud checkEminiJunkieMACloud = new EminiJunkieMACloud();
        private static EminiJunkieSMI checkEminiJunkieSMI = new EminiJunkieSMI();
        private static EminiJunkieSpread checkEminiJunkieSpread = new EminiJunkieSpread();
        private static EminiJunkieTrailingStop checkEminiJunkieTrailingStop = new EminiJunkieTrailingStop();

        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieBands EminiJunkieBands(double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            return EminiJunkieBands(Input, junkieBand01_Top, junkieBand01Bottom, junkieBand02_Top, junkieBand02Bottom, junkieBand03_Top, junkieBand03Bottom, junkieBand04_Top, junkieBand04Bottom, junkieBand05_Top, junkieBand05Bottom, junkieBand06_Top, junkieBand06Bottom, junkieBand07_Top, junkieBand07Bottom, junkieBand08_Top, junkieBand08Bottom, junkieBand09_Top, junkieBand09Bottom, junkieBand10_Top, junkieBand10Bottom, junkieBand11_Top, junkieBand11Bottom, junkieBand12_Top, junkieBand12Bottom, junkieBand13_Top, junkieBand13Bottom, junkieBand14_Top, junkieBand14Bottom, junkieBand15_Top, junkieBand15Bottom, junkieBand16_Top, junkieBand16Bottom, junkieBand17_Top, junkieBand17Bottom, junkieBand18_Top, junkieBand18Bottom, junkieBand19_Top, junkieBand19Bottom, junkieBand20_Top, junkieBand20Bottom);
        }

        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieBands EminiJunkieBands(Data.IDataSeries input, double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            if (cacheEminiJunkieBands != null)
                for (int idx = 0; idx < cacheEminiJunkieBands.Length; idx++)
                    if (Math.Abs(cacheEminiJunkieBands[idx].JunkieBand01_Top - junkieBand01_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand01Bottom - junkieBand01Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand02_Top - junkieBand02_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand02Bottom - junkieBand02Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand03_Top - junkieBand03_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand03Bottom - junkieBand03Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand04_Top - junkieBand04_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand04Bottom - junkieBand04Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand05_Top - junkieBand05_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand05Bottom - junkieBand05Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand06_Top - junkieBand06_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand06Bottom - junkieBand06Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand07_Top - junkieBand07_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand07Bottom - junkieBand07Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand08_Top - junkieBand08_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand08Bottom - junkieBand08Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand09_Top - junkieBand09_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand09Bottom - junkieBand09Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand10_Top - junkieBand10_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand10Bottom - junkieBand10Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand11_Top - junkieBand11_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand11Bottom - junkieBand11Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand12_Top - junkieBand12_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand12Bottom - junkieBand12Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand13_Top - junkieBand13_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand13Bottom - junkieBand13Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand14_Top - junkieBand14_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand14Bottom - junkieBand14Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand15_Top - junkieBand15_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand15Bottom - junkieBand15Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand16_Top - junkieBand16_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand16Bottom - junkieBand16Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand17_Top - junkieBand17_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand17Bottom - junkieBand17Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand18_Top - junkieBand18_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand18Bottom - junkieBand18Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand19_Top - junkieBand19_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand19Bottom - junkieBand19Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand20_Top - junkieBand20_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand20Bottom - junkieBand20Bottom) <= double.Epsilon && cacheEminiJunkieBands[idx].EqualsInput(input))
                        return cacheEminiJunkieBands[idx];

            lock (checkEminiJunkieBands)
            {
                checkEminiJunkieBands.JunkieBand01_Top = junkieBand01_Top;
                junkieBand01_Top = checkEminiJunkieBands.JunkieBand01_Top;
                checkEminiJunkieBands.JunkieBand01Bottom = junkieBand01Bottom;
                junkieBand01Bottom = checkEminiJunkieBands.JunkieBand01Bottom;
                checkEminiJunkieBands.JunkieBand02_Top = junkieBand02_Top;
                junkieBand02_Top = checkEminiJunkieBands.JunkieBand02_Top;
                checkEminiJunkieBands.JunkieBand02Bottom = junkieBand02Bottom;
                junkieBand02Bottom = checkEminiJunkieBands.JunkieBand02Bottom;
                checkEminiJunkieBands.JunkieBand03_Top = junkieBand03_Top;
                junkieBand03_Top = checkEminiJunkieBands.JunkieBand03_Top;
                checkEminiJunkieBands.JunkieBand03Bottom = junkieBand03Bottom;
                junkieBand03Bottom = checkEminiJunkieBands.JunkieBand03Bottom;
                checkEminiJunkieBands.JunkieBand04_Top = junkieBand04_Top;
                junkieBand04_Top = checkEminiJunkieBands.JunkieBand04_Top;
                checkEminiJunkieBands.JunkieBand04Bottom = junkieBand04Bottom;
                junkieBand04Bottom = checkEminiJunkieBands.JunkieBand04Bottom;
                checkEminiJunkieBands.JunkieBand05_Top = junkieBand05_Top;
                junkieBand05_Top = checkEminiJunkieBands.JunkieBand05_Top;
                checkEminiJunkieBands.JunkieBand05Bottom = junkieBand05Bottom;
                junkieBand05Bottom = checkEminiJunkieBands.JunkieBand05Bottom;
                checkEminiJunkieBands.JunkieBand06_Top = junkieBand06_Top;
                junkieBand06_Top = checkEminiJunkieBands.JunkieBand06_Top;
                checkEminiJunkieBands.JunkieBand06Bottom = junkieBand06Bottom;
                junkieBand06Bottom = checkEminiJunkieBands.JunkieBand06Bottom;
                checkEminiJunkieBands.JunkieBand07_Top = junkieBand07_Top;
                junkieBand07_Top = checkEminiJunkieBands.JunkieBand07_Top;
                checkEminiJunkieBands.JunkieBand07Bottom = junkieBand07Bottom;
                junkieBand07Bottom = checkEminiJunkieBands.JunkieBand07Bottom;
                checkEminiJunkieBands.JunkieBand08_Top = junkieBand08_Top;
                junkieBand08_Top = checkEminiJunkieBands.JunkieBand08_Top;
                checkEminiJunkieBands.JunkieBand08Bottom = junkieBand08Bottom;
                junkieBand08Bottom = checkEminiJunkieBands.JunkieBand08Bottom;
                checkEminiJunkieBands.JunkieBand09_Top = junkieBand09_Top;
                junkieBand09_Top = checkEminiJunkieBands.JunkieBand09_Top;
                checkEminiJunkieBands.JunkieBand09Bottom = junkieBand09Bottom;
                junkieBand09Bottom = checkEminiJunkieBands.JunkieBand09Bottom;
                checkEminiJunkieBands.JunkieBand10_Top = junkieBand10_Top;
                junkieBand10_Top = checkEminiJunkieBands.JunkieBand10_Top;
                checkEminiJunkieBands.JunkieBand10Bottom = junkieBand10Bottom;
                junkieBand10Bottom = checkEminiJunkieBands.JunkieBand10Bottom;
                checkEminiJunkieBands.JunkieBand11_Top = junkieBand11_Top;
                junkieBand11_Top = checkEminiJunkieBands.JunkieBand11_Top;
                checkEminiJunkieBands.JunkieBand11Bottom = junkieBand11Bottom;
                junkieBand11Bottom = checkEminiJunkieBands.JunkieBand11Bottom;
                checkEminiJunkieBands.JunkieBand12_Top = junkieBand12_Top;
                junkieBand12_Top = checkEminiJunkieBands.JunkieBand12_Top;
                checkEminiJunkieBands.JunkieBand12Bottom = junkieBand12Bottom;
                junkieBand12Bottom = checkEminiJunkieBands.JunkieBand12Bottom;
                checkEminiJunkieBands.JunkieBand13_Top = junkieBand13_Top;
                junkieBand13_Top = checkEminiJunkieBands.JunkieBand13_Top;
                checkEminiJunkieBands.JunkieBand13Bottom = junkieBand13Bottom;
                junkieBand13Bottom = checkEminiJunkieBands.JunkieBand13Bottom;
                checkEminiJunkieBands.JunkieBand14_Top = junkieBand14_Top;
                junkieBand14_Top = checkEminiJunkieBands.JunkieBand14_Top;
                checkEminiJunkieBands.JunkieBand14Bottom = junkieBand14Bottom;
                junkieBand14Bottom = checkEminiJunkieBands.JunkieBand14Bottom;
                checkEminiJunkieBands.JunkieBand15_Top = junkieBand15_Top;
                junkieBand15_Top = checkEminiJunkieBands.JunkieBand15_Top;
                checkEminiJunkieBands.JunkieBand15Bottom = junkieBand15Bottom;
                junkieBand15Bottom = checkEminiJunkieBands.JunkieBand15Bottom;
                checkEminiJunkieBands.JunkieBand16_Top = junkieBand16_Top;
                junkieBand16_Top = checkEminiJunkieBands.JunkieBand16_Top;
                checkEminiJunkieBands.JunkieBand16Bottom = junkieBand16Bottom;
                junkieBand16Bottom = checkEminiJunkieBands.JunkieBand16Bottom;
                checkEminiJunkieBands.JunkieBand17_Top = junkieBand17_Top;
                junkieBand17_Top = checkEminiJunkieBands.JunkieBand17_Top;
                checkEminiJunkieBands.JunkieBand17Bottom = junkieBand17Bottom;
                junkieBand17Bottom = checkEminiJunkieBands.JunkieBand17Bottom;
                checkEminiJunkieBands.JunkieBand18_Top = junkieBand18_Top;
                junkieBand18_Top = checkEminiJunkieBands.JunkieBand18_Top;
                checkEminiJunkieBands.JunkieBand18Bottom = junkieBand18Bottom;
                junkieBand18Bottom = checkEminiJunkieBands.JunkieBand18Bottom;
                checkEminiJunkieBands.JunkieBand19_Top = junkieBand19_Top;
                junkieBand19_Top = checkEminiJunkieBands.JunkieBand19_Top;
                checkEminiJunkieBands.JunkieBand19Bottom = junkieBand19Bottom;
                junkieBand19Bottom = checkEminiJunkieBands.JunkieBand19Bottom;
                checkEminiJunkieBands.JunkieBand20_Top = junkieBand20_Top;
                junkieBand20_Top = checkEminiJunkieBands.JunkieBand20_Top;
                checkEminiJunkieBands.JunkieBand20Bottom = junkieBand20Bottom;
                junkieBand20Bottom = checkEminiJunkieBands.JunkieBand20Bottom;

                if (cacheEminiJunkieBands != null)
                    for (int idx = 0; idx < cacheEminiJunkieBands.Length; idx++)
                        if (Math.Abs(cacheEminiJunkieBands[idx].JunkieBand01_Top - junkieBand01_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand01Bottom - junkieBand01Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand02_Top - junkieBand02_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand02Bottom - junkieBand02Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand03_Top - junkieBand03_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand03Bottom - junkieBand03Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand04_Top - junkieBand04_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand04Bottom - junkieBand04Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand05_Top - junkieBand05_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand05Bottom - junkieBand05Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand06_Top - junkieBand06_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand06Bottom - junkieBand06Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand07_Top - junkieBand07_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand07Bottom - junkieBand07Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand08_Top - junkieBand08_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand08Bottom - junkieBand08Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand09_Top - junkieBand09_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand09Bottom - junkieBand09Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand10_Top - junkieBand10_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand10Bottom - junkieBand10Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand11_Top - junkieBand11_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand11Bottom - junkieBand11Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand12_Top - junkieBand12_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand12Bottom - junkieBand12Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand13_Top - junkieBand13_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand13Bottom - junkieBand13Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand14_Top - junkieBand14_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand14Bottom - junkieBand14Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand15_Top - junkieBand15_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand15Bottom - junkieBand15Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand16_Top - junkieBand16_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand16Bottom - junkieBand16Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand17_Top - junkieBand17_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand17Bottom - junkieBand17Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand18_Top - junkieBand18_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand18Bottom - junkieBand18Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand19_Top - junkieBand19_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand19Bottom - junkieBand19Bottom) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand20_Top - junkieBand20_Top) <= double.Epsilon && Math.Abs(cacheEminiJunkieBands[idx].JunkieBand20Bottom - junkieBand20Bottom) <= double.Epsilon && cacheEminiJunkieBands[idx].EqualsInput(input))
                            return cacheEminiJunkieBands[idx];

                EminiJunkieBands indicator = new EminiJunkieBands();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.JunkieBand01_Top = junkieBand01_Top;
                indicator.JunkieBand01Bottom = junkieBand01Bottom;
                indicator.JunkieBand02_Top = junkieBand02_Top;
                indicator.JunkieBand02Bottom = junkieBand02Bottom;
                indicator.JunkieBand03_Top = junkieBand03_Top;
                indicator.JunkieBand03Bottom = junkieBand03Bottom;
                indicator.JunkieBand04_Top = junkieBand04_Top;
                indicator.JunkieBand04Bottom = junkieBand04Bottom;
                indicator.JunkieBand05_Top = junkieBand05_Top;
                indicator.JunkieBand05Bottom = junkieBand05Bottom;
                indicator.JunkieBand06_Top = junkieBand06_Top;
                indicator.JunkieBand06Bottom = junkieBand06Bottom;
                indicator.JunkieBand07_Top = junkieBand07_Top;
                indicator.JunkieBand07Bottom = junkieBand07Bottom;
                indicator.JunkieBand08_Top = junkieBand08_Top;
                indicator.JunkieBand08Bottom = junkieBand08Bottom;
                indicator.JunkieBand09_Top = junkieBand09_Top;
                indicator.JunkieBand09Bottom = junkieBand09Bottom;
                indicator.JunkieBand10_Top = junkieBand10_Top;
                indicator.JunkieBand10Bottom = junkieBand10Bottom;
                indicator.JunkieBand11_Top = junkieBand11_Top;
                indicator.JunkieBand11Bottom = junkieBand11Bottom;
                indicator.JunkieBand12_Top = junkieBand12_Top;
                indicator.JunkieBand12Bottom = junkieBand12Bottom;
                indicator.JunkieBand13_Top = junkieBand13_Top;
                indicator.JunkieBand13Bottom = junkieBand13Bottom;
                indicator.JunkieBand14_Top = junkieBand14_Top;
                indicator.JunkieBand14Bottom = junkieBand14Bottom;
                indicator.JunkieBand15_Top = junkieBand15_Top;
                indicator.JunkieBand15Bottom = junkieBand15Bottom;
                indicator.JunkieBand16_Top = junkieBand16_Top;
                indicator.JunkieBand16Bottom = junkieBand16Bottom;
                indicator.JunkieBand17_Top = junkieBand17_Top;
                indicator.JunkieBand17Bottom = junkieBand17Bottom;
                indicator.JunkieBand18_Top = junkieBand18_Top;
                indicator.JunkieBand18Bottom = junkieBand18Bottom;
                indicator.JunkieBand19_Top = junkieBand19_Top;
                indicator.JunkieBand19Bottom = junkieBand19Bottom;
                indicator.JunkieBand20_Top = junkieBand20_Top;
                indicator.JunkieBand20Bottom = junkieBand20Bottom;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieBands[] tmp = new EminiJunkieBands[cacheEminiJunkieBands == null ? 1 : cacheEminiJunkieBands.Length + 1];
                if (cacheEminiJunkieBands != null)
                    cacheEminiJunkieBands.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieBands = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public EminiJunkieBIAS EminiJunkieBIAS(BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            return EminiJunkieBIAS(Input, biasDisplayMode, biasMinutePeriod, longTickPeriod, simpleModeMinutePeriodFast, simpleModeMinutePeriodSlow);
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public EminiJunkieBIAS EminiJunkieBIAS(Data.IDataSeries input, BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            if (cacheEminiJunkieBIAS != null)
                for (int idx = 0; idx < cacheEminiJunkieBIAS.Length; idx++)
                    if (cacheEminiJunkieBIAS[idx].BiasDisplayMode == biasDisplayMode && cacheEminiJunkieBIAS[idx].BiasMinutePeriod == biasMinutePeriod && cacheEminiJunkieBIAS[idx].LongTickPeriod == longTickPeriod && cacheEminiJunkieBIAS[idx].SimpleModeMinutePeriodFast == simpleModeMinutePeriodFast && cacheEminiJunkieBIAS[idx].SimpleModeMinutePeriodSlow == simpleModeMinutePeriodSlow && cacheEminiJunkieBIAS[idx].EqualsInput(input))
                        return cacheEminiJunkieBIAS[idx];

            lock (checkEminiJunkieBIAS)
            {
                checkEminiJunkieBIAS.BiasDisplayMode = biasDisplayMode;
                biasDisplayMode = checkEminiJunkieBIAS.BiasDisplayMode;
                checkEminiJunkieBIAS.BiasMinutePeriod = biasMinutePeriod;
                biasMinutePeriod = checkEminiJunkieBIAS.BiasMinutePeriod;
                checkEminiJunkieBIAS.LongTickPeriod = longTickPeriod;
                longTickPeriod = checkEminiJunkieBIAS.LongTickPeriod;
                checkEminiJunkieBIAS.SimpleModeMinutePeriodFast = simpleModeMinutePeriodFast;
                simpleModeMinutePeriodFast = checkEminiJunkieBIAS.SimpleModeMinutePeriodFast;
                checkEminiJunkieBIAS.SimpleModeMinutePeriodSlow = simpleModeMinutePeriodSlow;
                simpleModeMinutePeriodSlow = checkEminiJunkieBIAS.SimpleModeMinutePeriodSlow;

                if (cacheEminiJunkieBIAS != null)
                    for (int idx = 0; idx < cacheEminiJunkieBIAS.Length; idx++)
                        if (cacheEminiJunkieBIAS[idx].BiasDisplayMode == biasDisplayMode && cacheEminiJunkieBIAS[idx].BiasMinutePeriod == biasMinutePeriod && cacheEminiJunkieBIAS[idx].LongTickPeriod == longTickPeriod && cacheEminiJunkieBIAS[idx].SimpleModeMinutePeriodFast == simpleModeMinutePeriodFast && cacheEminiJunkieBIAS[idx].SimpleModeMinutePeriodSlow == simpleModeMinutePeriodSlow && cacheEminiJunkieBIAS[idx].EqualsInput(input))
                            return cacheEminiJunkieBIAS[idx];

                EminiJunkieBIAS indicator = new EminiJunkieBIAS();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BiasDisplayMode = biasDisplayMode;
                indicator.BiasMinutePeriod = biasMinutePeriod;
                indicator.LongTickPeriod = longTickPeriod;
                indicator.SimpleModeMinutePeriodFast = simpleModeMinutePeriodFast;
                indicator.SimpleModeMinutePeriodSlow = simpleModeMinutePeriodSlow;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieBIAS[] tmp = new EminiJunkieBIAS[cacheEminiJunkieBIAS == null ? 1 : cacheEminiJunkieBIAS.Length + 1];
                if (cacheEminiJunkieBIAS != null)
                    cacheEminiJunkieBIAS.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieBIAS = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public EminiJunkieChop EminiJunkieChop(ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            return EminiJunkieChop(Input, chopDisplayMode, entireMALookback, entireMARange, mA_123Range, mA_3FlatnessLookback, mA_3FlatnessRange, mA_4DistanceAnyMA, mA1Period, mA1Type, mA2Period, mA2Type, mA3Period, mA3Type, mA4Period, mA4Type);
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public EminiJunkieChop EminiJunkieChop(Data.IDataSeries input, ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            if (cacheEminiJunkieChop != null)
                for (int idx = 0; idx < cacheEminiJunkieChop.Length; idx++)
                    if (cacheEminiJunkieChop[idx].ChopDisplayMode == chopDisplayMode && cacheEminiJunkieChop[idx].EntireMALookback == entireMALookback && cacheEminiJunkieChop[idx].EntireMARange == entireMARange && cacheEminiJunkieChop[idx].MA_123Range == mA_123Range && cacheEminiJunkieChop[idx].MA_3FlatnessLookback == mA_3FlatnessLookback && cacheEminiJunkieChop[idx].MA_3FlatnessRange == mA_3FlatnessRange && cacheEminiJunkieChop[idx].MA_4DistanceAnyMA == mA_4DistanceAnyMA && cacheEminiJunkieChop[idx].MA1Period == mA1Period && cacheEminiJunkieChop[idx].MA1Type == mA1Type && cacheEminiJunkieChop[idx].MA2Period == mA2Period && cacheEminiJunkieChop[idx].MA2Type == mA2Type && cacheEminiJunkieChop[idx].MA3Period == mA3Period && cacheEminiJunkieChop[idx].MA3Type == mA3Type && cacheEminiJunkieChop[idx].MA4Period == mA4Period && cacheEminiJunkieChop[idx].MA4Type == mA4Type && cacheEminiJunkieChop[idx].EqualsInput(input))
                        return cacheEminiJunkieChop[idx];

            lock (checkEminiJunkieChop)
            {
                checkEminiJunkieChop.ChopDisplayMode = chopDisplayMode;
                chopDisplayMode = checkEminiJunkieChop.ChopDisplayMode;
                checkEminiJunkieChop.EntireMALookback = entireMALookback;
                entireMALookback = checkEminiJunkieChop.EntireMALookback;
                checkEminiJunkieChop.EntireMARange = entireMARange;
                entireMARange = checkEminiJunkieChop.EntireMARange;
                checkEminiJunkieChop.MA_123Range = mA_123Range;
                mA_123Range = checkEminiJunkieChop.MA_123Range;
                checkEminiJunkieChop.MA_3FlatnessLookback = mA_3FlatnessLookback;
                mA_3FlatnessLookback = checkEminiJunkieChop.MA_3FlatnessLookback;
                checkEminiJunkieChop.MA_3FlatnessRange = mA_3FlatnessRange;
                mA_3FlatnessRange = checkEminiJunkieChop.MA_3FlatnessRange;
                checkEminiJunkieChop.MA_4DistanceAnyMA = mA_4DistanceAnyMA;
                mA_4DistanceAnyMA = checkEminiJunkieChop.MA_4DistanceAnyMA;
                checkEminiJunkieChop.MA1Period = mA1Period;
                mA1Period = checkEminiJunkieChop.MA1Period;
                checkEminiJunkieChop.MA1Type = mA1Type;
                mA1Type = checkEminiJunkieChop.MA1Type;
                checkEminiJunkieChop.MA2Period = mA2Period;
                mA2Period = checkEminiJunkieChop.MA2Period;
                checkEminiJunkieChop.MA2Type = mA2Type;
                mA2Type = checkEminiJunkieChop.MA2Type;
                checkEminiJunkieChop.MA3Period = mA3Period;
                mA3Period = checkEminiJunkieChop.MA3Period;
                checkEminiJunkieChop.MA3Type = mA3Type;
                mA3Type = checkEminiJunkieChop.MA3Type;
                checkEminiJunkieChop.MA4Period = mA4Period;
                mA4Period = checkEminiJunkieChop.MA4Period;
                checkEminiJunkieChop.MA4Type = mA4Type;
                mA4Type = checkEminiJunkieChop.MA4Type;

                if (cacheEminiJunkieChop != null)
                    for (int idx = 0; idx < cacheEminiJunkieChop.Length; idx++)
                        if (cacheEminiJunkieChop[idx].ChopDisplayMode == chopDisplayMode && cacheEminiJunkieChop[idx].EntireMALookback == entireMALookback && cacheEminiJunkieChop[idx].EntireMARange == entireMARange && cacheEminiJunkieChop[idx].MA_123Range == mA_123Range && cacheEminiJunkieChop[idx].MA_3FlatnessLookback == mA_3FlatnessLookback && cacheEminiJunkieChop[idx].MA_3FlatnessRange == mA_3FlatnessRange && cacheEminiJunkieChop[idx].MA_4DistanceAnyMA == mA_4DistanceAnyMA && cacheEminiJunkieChop[idx].MA1Period == mA1Period && cacheEminiJunkieChop[idx].MA1Type == mA1Type && cacheEminiJunkieChop[idx].MA2Period == mA2Period && cacheEminiJunkieChop[idx].MA2Type == mA2Type && cacheEminiJunkieChop[idx].MA3Period == mA3Period && cacheEminiJunkieChop[idx].MA3Type == mA3Type && cacheEminiJunkieChop[idx].MA4Period == mA4Period && cacheEminiJunkieChop[idx].MA4Type == mA4Type && cacheEminiJunkieChop[idx].EqualsInput(input))
                            return cacheEminiJunkieChop[idx];

                EminiJunkieChop indicator = new EminiJunkieChop();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.ChopDisplayMode = chopDisplayMode;
                indicator.EntireMALookback = entireMALookback;
                indicator.EntireMARange = entireMARange;
                indicator.MA_123Range = mA_123Range;
                indicator.MA_3FlatnessLookback = mA_3FlatnessLookback;
                indicator.MA_3FlatnessRange = mA_3FlatnessRange;
                indicator.MA_4DistanceAnyMA = mA_4DistanceAnyMA;
                indicator.MA1Period = mA1Period;
                indicator.MA1Type = mA1Type;
                indicator.MA2Period = mA2Period;
                indicator.MA2Type = mA2Type;
                indicator.MA3Period = mA3Period;
                indicator.MA3Type = mA3Type;
                indicator.MA4Period = mA4Period;
                indicator.MA4Type = mA4Type;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieChop[] tmp = new EminiJunkieChop[cacheEminiJunkieChop == null ? 1 : cacheEminiJunkieChop.Length + 1];
                if (cacheEminiJunkieChop != null)
                    cacheEminiJunkieChop.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieChop = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieKeyLevels EminiJunkieKeyLevels()
        {
            return EminiJunkieKeyLevels(Input);
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieKeyLevels EminiJunkieKeyLevels(Data.IDataSeries input)
        {
            if (cacheEminiJunkieKeyLevels != null)
                for (int idx = 0; idx < cacheEminiJunkieKeyLevels.Length; idx++)
                    if (cacheEminiJunkieKeyLevels[idx].EqualsInput(input))
                        return cacheEminiJunkieKeyLevels[idx];

            lock (checkEminiJunkieKeyLevels)
            {
                if (cacheEminiJunkieKeyLevels != null)
                    for (int idx = 0; idx < cacheEminiJunkieKeyLevels.Length; idx++)
                        if (cacheEminiJunkieKeyLevels[idx].EqualsInput(input))
                            return cacheEminiJunkieKeyLevels[idx];

                EminiJunkieKeyLevels indicator = new EminiJunkieKeyLevels();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieKeyLevels[] tmp = new EminiJunkieKeyLevels[cacheEminiJunkieKeyLevels == null ? 1 : cacheEminiJunkieKeyLevels.Length + 1];
                if (cacheEminiJunkieKeyLevels != null)
                    cacheEminiJunkieKeyLevels.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieKeyLevels = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieKIS EminiJunkieKIS(int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            return EminiJunkieKIS(Input, blueEMAPeriod, cyanSMAPeriod, esBiasFilter, esChopFilter, esSmiFilter, esSmiLongThreshold, esSmiShortThreshold, goldSMAPeriod, kisContractMode, kisDisplay, kisOppositeSignal, kisPerformance, magentaEMAPeriod, onlyShowSignalsInDirnBias, onlyShowSignalsInTimeWindow, redEMAPeriod, timeWindowBeginEST, timeWindowEndEST);
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieKIS EminiJunkieKIS(Data.IDataSeries input, int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            if (cacheEminiJunkieKIS != null)
                for (int idx = 0; idx < cacheEminiJunkieKIS.Length; idx++)
                    if (cacheEminiJunkieKIS[idx].BlueEMAPeriod == blueEMAPeriod && cacheEminiJunkieKIS[idx].CyanSMAPeriod == cyanSMAPeriod && cacheEminiJunkieKIS[idx].EsBiasFilter == esBiasFilter && cacheEminiJunkieKIS[idx].EsChopFilter == esChopFilter && cacheEminiJunkieKIS[idx].EsSmiFilter == esSmiFilter && Math.Abs(cacheEminiJunkieKIS[idx].EsSmiLongThreshold - esSmiLongThreshold) <= double.Epsilon && Math.Abs(cacheEminiJunkieKIS[idx].EsSmiShortThreshold - esSmiShortThreshold) <= double.Epsilon && cacheEminiJunkieKIS[idx].GoldSMAPeriod == goldSMAPeriod && cacheEminiJunkieKIS[idx].KisContractMode == kisContractMode && cacheEminiJunkieKIS[idx].KisDisplay == kisDisplay && cacheEminiJunkieKIS[idx].KisOppositeSignal == kisOppositeSignal && cacheEminiJunkieKIS[idx].KisPerformance == kisPerformance && cacheEminiJunkieKIS[idx].MagentaEMAPeriod == magentaEMAPeriod && cacheEminiJunkieKIS[idx].OnlyShowSignalsInDirnBias == onlyShowSignalsInDirnBias && cacheEminiJunkieKIS[idx].OnlyShowSignalsInTimeWindow == onlyShowSignalsInTimeWindow && cacheEminiJunkieKIS[idx].RedEMAPeriod == redEMAPeriod && cacheEminiJunkieKIS[idx].TimeWindowBeginEST == timeWindowBeginEST && cacheEminiJunkieKIS[idx].TimeWindowEndEST == timeWindowEndEST && cacheEminiJunkieKIS[idx].EqualsInput(input))
                        return cacheEminiJunkieKIS[idx];

            lock (checkEminiJunkieKIS)
            {
                checkEminiJunkieKIS.BlueEMAPeriod = blueEMAPeriod;
                blueEMAPeriod = checkEminiJunkieKIS.BlueEMAPeriod;
                checkEminiJunkieKIS.CyanSMAPeriod = cyanSMAPeriod;
                cyanSMAPeriod = checkEminiJunkieKIS.CyanSMAPeriod;
                checkEminiJunkieKIS.EsBiasFilter = esBiasFilter;
                esBiasFilter = checkEminiJunkieKIS.EsBiasFilter;
                checkEminiJunkieKIS.EsChopFilter = esChopFilter;
                esChopFilter = checkEminiJunkieKIS.EsChopFilter;
                checkEminiJunkieKIS.EsSmiFilter = esSmiFilter;
                esSmiFilter = checkEminiJunkieKIS.EsSmiFilter;
                checkEminiJunkieKIS.EsSmiLongThreshold = esSmiLongThreshold;
                esSmiLongThreshold = checkEminiJunkieKIS.EsSmiLongThreshold;
                checkEminiJunkieKIS.EsSmiShortThreshold = esSmiShortThreshold;
                esSmiShortThreshold = checkEminiJunkieKIS.EsSmiShortThreshold;
                checkEminiJunkieKIS.GoldSMAPeriod = goldSMAPeriod;
                goldSMAPeriod = checkEminiJunkieKIS.GoldSMAPeriod;
                checkEminiJunkieKIS.KisContractMode = kisContractMode;
                kisContractMode = checkEminiJunkieKIS.KisContractMode;
                checkEminiJunkieKIS.KisDisplay = kisDisplay;
                kisDisplay = checkEminiJunkieKIS.KisDisplay;
                checkEminiJunkieKIS.KisOppositeSignal = kisOppositeSignal;
                kisOppositeSignal = checkEminiJunkieKIS.KisOppositeSignal;
                checkEminiJunkieKIS.KisPerformance = kisPerformance;
                kisPerformance = checkEminiJunkieKIS.KisPerformance;
                checkEminiJunkieKIS.MagentaEMAPeriod = magentaEMAPeriod;
                magentaEMAPeriod = checkEminiJunkieKIS.MagentaEMAPeriod;
                checkEminiJunkieKIS.OnlyShowSignalsInDirnBias = onlyShowSignalsInDirnBias;
                onlyShowSignalsInDirnBias = checkEminiJunkieKIS.OnlyShowSignalsInDirnBias;
                checkEminiJunkieKIS.OnlyShowSignalsInTimeWindow = onlyShowSignalsInTimeWindow;
                onlyShowSignalsInTimeWindow = checkEminiJunkieKIS.OnlyShowSignalsInTimeWindow;
                checkEminiJunkieKIS.RedEMAPeriod = redEMAPeriod;
                redEMAPeriod = checkEminiJunkieKIS.RedEMAPeriod;
                checkEminiJunkieKIS.TimeWindowBeginEST = timeWindowBeginEST;
                timeWindowBeginEST = checkEminiJunkieKIS.TimeWindowBeginEST;
                checkEminiJunkieKIS.TimeWindowEndEST = timeWindowEndEST;
                timeWindowEndEST = checkEminiJunkieKIS.TimeWindowEndEST;

                if (cacheEminiJunkieKIS != null)
                    for (int idx = 0; idx < cacheEminiJunkieKIS.Length; idx++)
                        if (cacheEminiJunkieKIS[idx].BlueEMAPeriod == blueEMAPeriod && cacheEminiJunkieKIS[idx].CyanSMAPeriod == cyanSMAPeriod && cacheEminiJunkieKIS[idx].EsBiasFilter == esBiasFilter && cacheEminiJunkieKIS[idx].EsChopFilter == esChopFilter && cacheEminiJunkieKIS[idx].EsSmiFilter == esSmiFilter && Math.Abs(cacheEminiJunkieKIS[idx].EsSmiLongThreshold - esSmiLongThreshold) <= double.Epsilon && Math.Abs(cacheEminiJunkieKIS[idx].EsSmiShortThreshold - esSmiShortThreshold) <= double.Epsilon && cacheEminiJunkieKIS[idx].GoldSMAPeriod == goldSMAPeriod && cacheEminiJunkieKIS[idx].KisContractMode == kisContractMode && cacheEminiJunkieKIS[idx].KisDisplay == kisDisplay && cacheEminiJunkieKIS[idx].KisOppositeSignal == kisOppositeSignal && cacheEminiJunkieKIS[idx].KisPerformance == kisPerformance && cacheEminiJunkieKIS[idx].MagentaEMAPeriod == magentaEMAPeriod && cacheEminiJunkieKIS[idx].OnlyShowSignalsInDirnBias == onlyShowSignalsInDirnBias && cacheEminiJunkieKIS[idx].OnlyShowSignalsInTimeWindow == onlyShowSignalsInTimeWindow && cacheEminiJunkieKIS[idx].RedEMAPeriod == redEMAPeriod && cacheEminiJunkieKIS[idx].TimeWindowBeginEST == timeWindowBeginEST && cacheEminiJunkieKIS[idx].TimeWindowEndEST == timeWindowEndEST && cacheEminiJunkieKIS[idx].EqualsInput(input))
                            return cacheEminiJunkieKIS[idx];

                EminiJunkieKIS indicator = new EminiJunkieKIS();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BlueEMAPeriod = blueEMAPeriod;
                indicator.CyanSMAPeriod = cyanSMAPeriod;
                indicator.EsBiasFilter = esBiasFilter;
                indicator.EsChopFilter = esChopFilter;
                indicator.EsSmiFilter = esSmiFilter;
                indicator.EsSmiLongThreshold = esSmiLongThreshold;
                indicator.EsSmiShortThreshold = esSmiShortThreshold;
                indicator.GoldSMAPeriod = goldSMAPeriod;
                indicator.KisContractMode = kisContractMode;
                indicator.KisDisplay = kisDisplay;
                indicator.KisOppositeSignal = kisOppositeSignal;
                indicator.KisPerformance = kisPerformance;
                indicator.MagentaEMAPeriod = magentaEMAPeriod;
                indicator.OnlyShowSignalsInDirnBias = onlyShowSignalsInDirnBias;
                indicator.OnlyShowSignalsInTimeWindow = onlyShowSignalsInTimeWindow;
                indicator.RedEMAPeriod = redEMAPeriod;
                indicator.TimeWindowBeginEST = timeWindowBeginEST;
                indicator.TimeWindowEndEST = timeWindowEndEST;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieKIS[] tmp = new EminiJunkieKIS[cacheEminiJunkieKIS == null ? 1 : cacheEminiJunkieKIS.Length + 1];
                if (cacheEminiJunkieKIS != null)
                    cacheEminiJunkieKIS.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieKIS = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieMACloud EminiJunkieMACloud(int mALength1, int mALength2, string mAType1, string mAType2)
        {
            return EminiJunkieMACloud(Input, mALength1, mALength2, mAType1, mAType2);
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieMACloud EminiJunkieMACloud(Data.IDataSeries input, int mALength1, int mALength2, string mAType1, string mAType2)
        {
            if (cacheEminiJunkieMACloud != null)
                for (int idx = 0; idx < cacheEminiJunkieMACloud.Length; idx++)
                    if (cacheEminiJunkieMACloud[idx].MALength1 == mALength1 && cacheEminiJunkieMACloud[idx].MALength2 == mALength2 && cacheEminiJunkieMACloud[idx].MAType1 == mAType1 && cacheEminiJunkieMACloud[idx].MAType2 == mAType2 && cacheEminiJunkieMACloud[idx].EqualsInput(input))
                        return cacheEminiJunkieMACloud[idx];

            lock (checkEminiJunkieMACloud)
            {
                checkEminiJunkieMACloud.MALength1 = mALength1;
                mALength1 = checkEminiJunkieMACloud.MALength1;
                checkEminiJunkieMACloud.MALength2 = mALength2;
                mALength2 = checkEminiJunkieMACloud.MALength2;
                checkEminiJunkieMACloud.MAType1 = mAType1;
                mAType1 = checkEminiJunkieMACloud.MAType1;
                checkEminiJunkieMACloud.MAType2 = mAType2;
                mAType2 = checkEminiJunkieMACloud.MAType2;

                if (cacheEminiJunkieMACloud != null)
                    for (int idx = 0; idx < cacheEminiJunkieMACloud.Length; idx++)
                        if (cacheEminiJunkieMACloud[idx].MALength1 == mALength1 && cacheEminiJunkieMACloud[idx].MALength2 == mALength2 && cacheEminiJunkieMACloud[idx].MAType1 == mAType1 && cacheEminiJunkieMACloud[idx].MAType2 == mAType2 && cacheEminiJunkieMACloud[idx].EqualsInput(input))
                            return cacheEminiJunkieMACloud[idx];

                EminiJunkieMACloud indicator = new EminiJunkieMACloud();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.MALength1 = mALength1;
                indicator.MALength2 = mALength2;
                indicator.MAType1 = mAType1;
                indicator.MAType2 = mAType2;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieMACloud[] tmp = new EminiJunkieMACloud[cacheEminiJunkieMACloud == null ? 1 : cacheEminiJunkieMACloud.Length + 1];
                if (cacheEminiJunkieMACloud != null)
                    cacheEminiJunkieMACloud.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieMACloud = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieSMI EminiJunkieSMI(int percentDLength, int percentKLength)
        {
            return EminiJunkieSMI(Input, percentDLength, percentKLength);
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieSMI EminiJunkieSMI(Data.IDataSeries input, int percentDLength, int percentKLength)
        {
            if (cacheEminiJunkieSMI != null)
                for (int idx = 0; idx < cacheEminiJunkieSMI.Length; idx++)
                    if (cacheEminiJunkieSMI[idx].PercentDLength == percentDLength && cacheEminiJunkieSMI[idx].PercentKLength == percentKLength && cacheEminiJunkieSMI[idx].EqualsInput(input))
                        return cacheEminiJunkieSMI[idx];

            lock (checkEminiJunkieSMI)
            {
                checkEminiJunkieSMI.PercentDLength = percentDLength;
                percentDLength = checkEminiJunkieSMI.PercentDLength;
                checkEminiJunkieSMI.PercentKLength = percentKLength;
                percentKLength = checkEminiJunkieSMI.PercentKLength;

                if (cacheEminiJunkieSMI != null)
                    for (int idx = 0; idx < cacheEminiJunkieSMI.Length; idx++)
                        if (cacheEminiJunkieSMI[idx].PercentDLength == percentDLength && cacheEminiJunkieSMI[idx].PercentKLength == percentKLength && cacheEminiJunkieSMI[idx].EqualsInput(input))
                            return cacheEminiJunkieSMI[idx];

                EminiJunkieSMI indicator = new EminiJunkieSMI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.PercentDLength = percentDLength;
                indicator.PercentKLength = percentKLength;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieSMI[] tmp = new EminiJunkieSMI[cacheEminiJunkieSMI == null ? 1 : cacheEminiJunkieSMI.Length + 1];
                if (cacheEminiJunkieSMI != null)
                    cacheEminiJunkieSMI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieSMI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieSpread EminiJunkieSpread(double qty1, double qty2, string symbol2)
        {
            return EminiJunkieSpread(Input, qty1, qty2, symbol2);
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieSpread EminiJunkieSpread(Data.IDataSeries input, double qty1, double qty2, string symbol2)
        {
            if (cacheEminiJunkieSpread != null)
                for (int idx = 0; idx < cacheEminiJunkieSpread.Length; idx++)
                    if (Math.Abs(cacheEminiJunkieSpread[idx].Qty1 - qty1) <= double.Epsilon && Math.Abs(cacheEminiJunkieSpread[idx].Qty2 - qty2) <= double.Epsilon && cacheEminiJunkieSpread[idx].Symbol2 == symbol2 && cacheEminiJunkieSpread[idx].EqualsInput(input))
                        return cacheEminiJunkieSpread[idx];

            lock (checkEminiJunkieSpread)
            {
                checkEminiJunkieSpread.Qty1 = qty1;
                qty1 = checkEminiJunkieSpread.Qty1;
                checkEminiJunkieSpread.Qty2 = qty2;
                qty2 = checkEminiJunkieSpread.Qty2;
                checkEminiJunkieSpread.Symbol2 = symbol2;
                symbol2 = checkEminiJunkieSpread.Symbol2;

                if (cacheEminiJunkieSpread != null)
                    for (int idx = 0; idx < cacheEminiJunkieSpread.Length; idx++)
                        if (Math.Abs(cacheEminiJunkieSpread[idx].Qty1 - qty1) <= double.Epsilon && Math.Abs(cacheEminiJunkieSpread[idx].Qty2 - qty2) <= double.Epsilon && cacheEminiJunkieSpread[idx].Symbol2 == symbol2 && cacheEminiJunkieSpread[idx].EqualsInput(input))
                            return cacheEminiJunkieSpread[idx];

                EminiJunkieSpread indicator = new EminiJunkieSpread();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Qty1 = qty1;
                indicator.Qty2 = qty2;
                indicator.Symbol2 = symbol2;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieSpread[] tmp = new EminiJunkieSpread[cacheEminiJunkieSpread == null ? 1 : cacheEminiJunkieSpread.Length + 1];
                if (cacheEminiJunkieSpread != null)
                    cacheEminiJunkieSpread.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieSpread = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieTrailingStop EminiJunkieTrailingStop(double factor, int period)
        {
            return EminiJunkieTrailingStop(Input, factor, period);
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        public EminiJunkieTrailingStop EminiJunkieTrailingStop(Data.IDataSeries input, double factor, int period)
        {
            if (cacheEminiJunkieTrailingStop != null)
                for (int idx = 0; idx < cacheEminiJunkieTrailingStop.Length; idx++)
                    if (Math.Abs(cacheEminiJunkieTrailingStop[idx].Factor - factor) <= double.Epsilon && cacheEminiJunkieTrailingStop[idx].Period == period && cacheEminiJunkieTrailingStop[idx].EqualsInput(input))
                        return cacheEminiJunkieTrailingStop[idx];

            lock (checkEminiJunkieTrailingStop)
            {
                checkEminiJunkieTrailingStop.Factor = factor;
                factor = checkEminiJunkieTrailingStop.Factor;
                checkEminiJunkieTrailingStop.Period = period;
                period = checkEminiJunkieTrailingStop.Period;

                if (cacheEminiJunkieTrailingStop != null)
                    for (int idx = 0; idx < cacheEminiJunkieTrailingStop.Length; idx++)
                        if (Math.Abs(cacheEminiJunkieTrailingStop[idx].Factor - factor) <= double.Epsilon && cacheEminiJunkieTrailingStop[idx].Period == period && cacheEminiJunkieTrailingStop[idx].EqualsInput(input))
                            return cacheEminiJunkieTrailingStop[idx];

                EminiJunkieTrailingStop indicator = new EminiJunkieTrailingStop();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Factor = factor;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                EminiJunkieTrailingStop[] tmp = new EminiJunkieTrailingStop[cacheEminiJunkieTrailingStop == null ? 1 : cacheEminiJunkieTrailingStop.Length + 1];
                if (cacheEminiJunkieTrailingStop != null)
                    cacheEminiJunkieTrailingStop.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEminiJunkieTrailingStop = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieBands EminiJunkieBands(double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            return _indicator.EminiJunkieBands(Input, junkieBand01_Top, junkieBand01Bottom, junkieBand02_Top, junkieBand02Bottom, junkieBand03_Top, junkieBand03Bottom, junkieBand04_Top, junkieBand04Bottom, junkieBand05_Top, junkieBand05Bottom, junkieBand06_Top, junkieBand06Bottom, junkieBand07_Top, junkieBand07Bottom, junkieBand08_Top, junkieBand08Bottom, junkieBand09_Top, junkieBand09Bottom, junkieBand10_Top, junkieBand10Bottom, junkieBand11_Top, junkieBand11Bottom, junkieBand12_Top, junkieBand12Bottom, junkieBand13_Top, junkieBand13Bottom, junkieBand14_Top, junkieBand14Bottom, junkieBand15_Top, junkieBand15Bottom, junkieBand16_Top, junkieBand16Bottom, junkieBand17_Top, junkieBand17Bottom, junkieBand18_Top, junkieBand18Bottom, junkieBand19_Top, junkieBand19Bottom, junkieBand20_Top, junkieBand20Bottom);
        }

        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieBands EminiJunkieBands(Data.IDataSeries input, double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            return _indicator.EminiJunkieBands(input, junkieBand01_Top, junkieBand01Bottom, junkieBand02_Top, junkieBand02Bottom, junkieBand03_Top, junkieBand03Bottom, junkieBand04_Top, junkieBand04Bottom, junkieBand05_Top, junkieBand05Bottom, junkieBand06_Top, junkieBand06Bottom, junkieBand07_Top, junkieBand07Bottom, junkieBand08_Top, junkieBand08Bottom, junkieBand09_Top, junkieBand09Bottom, junkieBand10_Top, junkieBand10Bottom, junkieBand11_Top, junkieBand11Bottom, junkieBand12_Top, junkieBand12Bottom, junkieBand13_Top, junkieBand13Bottom, junkieBand14_Top, junkieBand14Bottom, junkieBand15_Top, junkieBand15Bottom, junkieBand16_Top, junkieBand16Bottom, junkieBand17_Top, junkieBand17Bottom, junkieBand18_Top, junkieBand18Bottom, junkieBand19_Top, junkieBand19Bottom, junkieBand20_Top, junkieBand20Bottom);
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieBIAS EminiJunkieBIAS(BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            return _indicator.EminiJunkieBIAS(Input, biasDisplayMode, biasMinutePeriod, longTickPeriod, simpleModeMinutePeriodFast, simpleModeMinutePeriodSlow);
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieBIAS EminiJunkieBIAS(Data.IDataSeries input, BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            return _indicator.EminiJunkieBIAS(input, biasDisplayMode, biasMinutePeriod, longTickPeriod, simpleModeMinutePeriodFast, simpleModeMinutePeriodSlow);
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieChop EminiJunkieChop(ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            return _indicator.EminiJunkieChop(Input, chopDisplayMode, entireMALookback, entireMARange, mA_123Range, mA_3FlatnessLookback, mA_3FlatnessRange, mA_4DistanceAnyMA, mA1Period, mA1Type, mA2Period, mA2Type, mA3Period, mA3Type, mA4Period, mA4Type);
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieChop EminiJunkieChop(Data.IDataSeries input, ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            return _indicator.EminiJunkieChop(input, chopDisplayMode, entireMALookback, entireMARange, mA_123Range, mA_3FlatnessLookback, mA_3FlatnessRange, mA_4DistanceAnyMA, mA1Period, mA1Type, mA2Period, mA2Type, mA3Period, mA3Type, mA4Period, mA4Type);
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieKeyLevels EminiJunkieKeyLevels()
        {
            return _indicator.EminiJunkieKeyLevels(Input);
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieKeyLevels EminiJunkieKeyLevels(Data.IDataSeries input)
        {
            return _indicator.EminiJunkieKeyLevels(input);
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieKIS EminiJunkieKIS(int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            return _indicator.EminiJunkieKIS(Input, blueEMAPeriod, cyanSMAPeriod, esBiasFilter, esChopFilter, esSmiFilter, esSmiLongThreshold, esSmiShortThreshold, goldSMAPeriod, kisContractMode, kisDisplay, kisOppositeSignal, kisPerformance, magentaEMAPeriod, onlyShowSignalsInDirnBias, onlyShowSignalsInTimeWindow, redEMAPeriod, timeWindowBeginEST, timeWindowEndEST);
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieKIS EminiJunkieKIS(Data.IDataSeries input, int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            return _indicator.EminiJunkieKIS(input, blueEMAPeriod, cyanSMAPeriod, esBiasFilter, esChopFilter, esSmiFilter, esSmiLongThreshold, esSmiShortThreshold, goldSMAPeriod, kisContractMode, kisDisplay, kisOppositeSignal, kisPerformance, magentaEMAPeriod, onlyShowSignalsInDirnBias, onlyShowSignalsInTimeWindow, redEMAPeriod, timeWindowBeginEST, timeWindowEndEST);
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieMACloud EminiJunkieMACloud(int mALength1, int mALength2, string mAType1, string mAType2)
        {
            return _indicator.EminiJunkieMACloud(Input, mALength1, mALength2, mAType1, mAType2);
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieMACloud EminiJunkieMACloud(Data.IDataSeries input, int mALength1, int mALength2, string mAType1, string mAType2)
        {
            return _indicator.EminiJunkieMACloud(input, mALength1, mALength2, mAType1, mAType2);
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieSMI EminiJunkieSMI(int percentDLength, int percentKLength)
        {
            return _indicator.EminiJunkieSMI(Input, percentDLength, percentKLength);
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieSMI EminiJunkieSMI(Data.IDataSeries input, int percentDLength, int percentKLength)
        {
            return _indicator.EminiJunkieSMI(input, percentDLength, percentKLength);
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieSpread EminiJunkieSpread(double qty1, double qty2, string symbol2)
        {
            return _indicator.EminiJunkieSpread(Input, qty1, qty2, symbol2);
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieSpread EminiJunkieSpread(Data.IDataSeries input, double qty1, double qty2, string symbol2)
        {
            return _indicator.EminiJunkieSpread(input, qty1, qty2, symbol2);
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieTrailingStop EminiJunkieTrailingStop(double factor, int period)
        {
            return _indicator.EminiJunkieTrailingStop(Input, factor, period);
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieTrailingStop EminiJunkieTrailingStop(Data.IDataSeries input, double factor, int period)
        {
            return _indicator.EminiJunkieTrailingStop(input, factor, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieBands EminiJunkieBands(double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            return _indicator.EminiJunkieBands(Input, junkieBand01_Top, junkieBand01Bottom, junkieBand02_Top, junkieBand02Bottom, junkieBand03_Top, junkieBand03Bottom, junkieBand04_Top, junkieBand04Bottom, junkieBand05_Top, junkieBand05Bottom, junkieBand06_Top, junkieBand06Bottom, junkieBand07_Top, junkieBand07Bottom, junkieBand08_Top, junkieBand08Bottom, junkieBand09_Top, junkieBand09Bottom, junkieBand10_Top, junkieBand10Bottom, junkieBand11_Top, junkieBand11Bottom, junkieBand12_Top, junkieBand12Bottom, junkieBand13_Top, junkieBand13Bottom, junkieBand14_Top, junkieBand14Bottom, junkieBand15_Top, junkieBand15Bottom, junkieBand16_Top, junkieBand16Bottom, junkieBand17_Top, junkieBand17Bottom, junkieBand18_Top, junkieBand18Bottom, junkieBand19_Top, junkieBand19Bottom, junkieBand20_Top, junkieBand20Bottom);
        }

        /// <summary>
        /// EminiJunkie.com JunkieBands Build [0008]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieBands EminiJunkieBands(Data.IDataSeries input, double junkieBand01_Top, double junkieBand01Bottom, double junkieBand02_Top, double junkieBand02Bottom, double junkieBand03_Top, double junkieBand03Bottom, double junkieBand04_Top, double junkieBand04Bottom, double junkieBand05_Top, double junkieBand05Bottom, double junkieBand06_Top, double junkieBand06Bottom, double junkieBand07_Top, double junkieBand07Bottom, double junkieBand08_Top, double junkieBand08Bottom, double junkieBand09_Top, double junkieBand09Bottom, double junkieBand10_Top, double junkieBand10Bottom, double junkieBand11_Top, double junkieBand11Bottom, double junkieBand12_Top, double junkieBand12Bottom, double junkieBand13_Top, double junkieBand13Bottom, double junkieBand14_Top, double junkieBand14Bottom, double junkieBand15_Top, double junkieBand15Bottom, double junkieBand16_Top, double junkieBand16Bottom, double junkieBand17_Top, double junkieBand17Bottom, double junkieBand18_Top, double junkieBand18Bottom, double junkieBand19_Top, double junkieBand19Bottom, double junkieBand20_Top, double junkieBand20Bottom)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieBands(input, junkieBand01_Top, junkieBand01Bottom, junkieBand02_Top, junkieBand02Bottom, junkieBand03_Top, junkieBand03Bottom, junkieBand04_Top, junkieBand04Bottom, junkieBand05_Top, junkieBand05Bottom, junkieBand06_Top, junkieBand06Bottom, junkieBand07_Top, junkieBand07Bottom, junkieBand08_Top, junkieBand08Bottom, junkieBand09_Top, junkieBand09Bottom, junkieBand10_Top, junkieBand10Bottom, junkieBand11_Top, junkieBand11Bottom, junkieBand12_Top, junkieBand12Bottom, junkieBand13_Top, junkieBand13Bottom, junkieBand14_Top, junkieBand14Bottom, junkieBand15_Top, junkieBand15Bottom, junkieBand16_Top, junkieBand16Bottom, junkieBand17_Top, junkieBand17Bottom, junkieBand18_Top, junkieBand18Bottom, junkieBand19_Top, junkieBand19Bottom, junkieBand20_Top, junkieBand20Bottom);
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieBIAS EminiJunkieBIAS(BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            return _indicator.EminiJunkieBIAS(Input, biasDisplayMode, biasMinutePeriod, longTickPeriod, simpleModeMinutePeriodFast, simpleModeMinutePeriodSlow);
        }

        /// <summary>
        /// Eminijunkie.com BIAS Indicator [Build 0053] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieBIAS EminiJunkieBIAS(Data.IDataSeries input, BIASShowMode biasDisplayMode, int biasMinutePeriod, int longTickPeriod, int simpleModeMinutePeriodFast, int simpleModeMinutePeriodSlow)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieBIAS(input, biasDisplayMode, biasMinutePeriod, longTickPeriod, simpleModeMinutePeriodFast, simpleModeMinutePeriodSlow);
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieChop EminiJunkieChop(ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            return _indicator.EminiJunkieChop(Input, chopDisplayMode, entireMALookback, entireMARange, mA_123Range, mA_3FlatnessLookback, mA_3FlatnessRange, mA_4DistanceAnyMA, mA1Period, mA1Type, mA2Period, mA2Type, mA3Period, mA3Type, mA4Period, mA4Type);
        }

        /// <summary>
        /// Eminijunkie.com Chop Indicator [Build 0019] Note: When adding this indicator, in Properties->Visual-> turn off Price Markers
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieChop EminiJunkieChop(Data.IDataSeries input, ChopShowMode chopDisplayMode, int entireMALookback, int entireMARange, int mA_123Range, int mA_3FlatnessLookback, int mA_3FlatnessRange, int mA_4DistanceAnyMA, int mA1Period, MovingAvgType mA1Type, int mA2Period, MovingAvgType mA2Type, int mA3Period, MovingAvgType mA3Type, int mA4Period, MovingAvgType mA4Type)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieChop(input, chopDisplayMode, entireMALookback, entireMARange, mA_123Range, mA_3FlatnessLookback, mA_3FlatnessRange, mA_4DistanceAnyMA, mA1Period, mA1Type, mA2Period, mA2Type, mA3Period, mA3Type, mA4Period, mA4Type);
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieKeyLevels EminiJunkieKeyLevels()
        {
            return _indicator.EminiJunkieKeyLevels(Input);
        }

        /// <summary>
        /// EminiJunkie.com Key Levels [Build 0050]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieKeyLevels EminiJunkieKeyLevels(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieKeyLevels(input);
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieKIS EminiJunkieKIS(int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            return _indicator.EminiJunkieKIS(Input, blueEMAPeriod, cyanSMAPeriod, esBiasFilter, esChopFilter, esSmiFilter, esSmiLongThreshold, esSmiShortThreshold, goldSMAPeriod, kisContractMode, kisDisplay, kisOppositeSignal, kisPerformance, magentaEMAPeriod, onlyShowSignalsInDirnBias, onlyShowSignalsInTimeWindow, redEMAPeriod, timeWindowBeginEST, timeWindowEndEST);
        }

        /// <summary>
        /// Eminijunkie.com KIS System [Build 0416]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieKIS EminiJunkieKIS(Data.IDataSeries input, int blueEMAPeriod, int cyanSMAPeriod, EsBIASEnableFilter esBiasFilter, EsChopEnableFilter esChopFilter, EsSMIEnableFilter esSmiFilter, double esSmiLongThreshold, double esSmiShortThreshold, int goldSMAPeriod, KisContractModeType kisContractMode, KisDisplayType kisDisplay, KisOppositeSignalType kisOppositeSignal, KisPerformanceType kisPerformance, int magentaEMAPeriod, KisOnlyShowSignalsInDirnBiasFilter onlyShowSignalsInDirnBias, KisOnlyShowSignalsInTimeWindowFilter onlyShowSignalsInTimeWindow, int redEMAPeriod, int timeWindowBeginEST, int timeWindowEndEST)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieKIS(input, blueEMAPeriod, cyanSMAPeriod, esBiasFilter, esChopFilter, esSmiFilter, esSmiLongThreshold, esSmiShortThreshold, goldSMAPeriod, kisContractMode, kisDisplay, kisOppositeSignal, kisPerformance, magentaEMAPeriod, onlyShowSignalsInDirnBias, onlyShowSignalsInTimeWindow, redEMAPeriod, timeWindowBeginEST, timeWindowEndEST);
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieMACloud EminiJunkieMACloud(int mALength1, int mALength2, string mAType1, string mAType2)
        {
            return _indicator.EminiJunkieMACloud(Input, mALength1, mALength2, mAType1, mAType2);
        }

        /// <summary>
        /// EminiJunkie MA Cloud [Build 0003]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieMACloud EminiJunkieMACloud(Data.IDataSeries input, int mALength1, int mALength2, string mAType1, string mAType2)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieMACloud(input, mALength1, mALength2, mAType1, mAType2);
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieSMI EminiJunkieSMI(int percentDLength, int percentKLength)
        {
            return _indicator.EminiJunkieSMI(Input, percentDLength, percentKLength);
        }

        /// <summary>
        /// EminiJunkie.com Stochastic Momentum Index [Build 0001]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieSMI EminiJunkieSMI(Data.IDataSeries input, int percentDLength, int percentKLength)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieSMI(input, percentDLength, percentKLength);
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieSpread EminiJunkieSpread(double qty1, double qty2, string symbol2)
        {
            return _indicator.EminiJunkieSpread(Input, qty1, qty2, symbol2);
        }

        /// <summary>
        /// Eminijunkie.com EminiJunkieSpread [Build 0002]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieSpread EminiJunkieSpread(Data.IDataSeries input, double qty1, double qty2, string symbol2)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieSpread(input, qty1, qty2, symbol2);
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EminiJunkieTrailingStop EminiJunkieTrailingStop(double factor, int period)
        {
            return _indicator.EminiJunkieTrailingStop(Input, factor, period);
        }

        /// <summary>
        /// Eminijunkie.com TrailingStop [Build 0011]
        /// </summary>
        /// <returns></returns>
        public Indicator.EminiJunkieTrailingStop EminiJunkieTrailingStop(Data.IDataSeries input, double factor, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EminiJunkieTrailingStop(input, factor, period);
        }
    }
}
#endregion
